#ifndef __FrameControl_H__
#define __FrameControl_H__

#include <FK/Window.h>


//=======================================================
//t[[g𐧌䂷NXłB
//======================================================
class fkut_FrameController {
public:
	fkut_FrameController(unsigned long dwFps = 60, bool bFrameSkip = true);
	~fkut_FrameController();
private:
	unsigned long m_dwLastFlipped;
	unsigned long m_dwLastMinitues;
	unsigned long m_dwFrameRate;
	unsigned long m_dwSkipRate;
	float m_fFrameTime;
	bool m_bDrawFlag;
	bool m_bFrameSkip;
		
	bool m_bInit;
	//=======================================================
	//݂̂PbPʂ̃[g̕\
	//======================================================
	unsigned long m_dwFrameCount;
	unsigned long m_dwSkipCount;

	static void SleepOneMSec(void);
public:
	void Measure();
	void SetFPS(unsigned long time);
	void OnFrameSkip(bool bFrameSkip);
	bool GetDrawFlag();
	void TimeRegular();
	unsigned long GetSkipRate();
	unsigned long GetFrameRate();
};

#endif
